#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "port_2k.h"
#include "mdi281.h"

void close(void);
void status_chk(BYTE expect, BYTE mask, char *message);

int resource_no;

void main(void)
{
	int	i, j, k,brd_num, rv, device_id[8], index[8], retc;
	BYTE data,sts;
	DWORD cntdt1,cntdt2;
	DWORD start_time;
	BOOL quit, err;

	for (i = 0; i <= 7; i++)
	{
		device_id[i] = -1;
		index[i] = -1;
	}

	brd_num = 0;
	rv = Open_Driver(device_id);
	if (rv != 0)
	{
		printf("Open_DriverŃG[(%d)܂B\n", rv);
		exit (-1);
	}

	for (i = 0; i <= 7; i++)
		if (DEVICE_ID ==device_id[i])
			index[brd_num++] = i;

	if (brd_num == 0)
	{
		printf("%soł܂B\n", BOARD_NAME);
		close();
	}
	else
		printf("%s%do܂B\n", BOARD_NAME, brd_num);
		printf("\n");

	for (i = 0; i < brd_num; i++)
	{
		printf("%dԖڂɌoꂽ{[h̃`FbN܂B\n", i + 1);
		rv = Start_Driver(index[i], 2, &resource_no);
		if (rv != 0)
		{
			printf("Open_DriverŃG[(%d)܂B\n", rv);
			close();
		}

		data = ReadWord(resource_no, RESET);
		if (data == BOARD_ID)
			printf("{[hID(%02xH)͐ŁA", data);
		else
		{
			printf("{[hID(=%02xH)ُ͈łB\n", data);
			close();
		}

		data = ReadWord(resource_no, BRDNUM);
		printf("{[hԍݒ(%x)łB\n", data & 0x0f);

		// Zbg̃Xe[^X`FbN
		status_chk(0x06, 0xff, "Zbg̃Xe[^X");

		// TvOX^[g̃tO`FbN
		WriteWord(resource_no, MODE, 0x1);		// FIFO MODE
//		WriteWord(resource_no, CLKDIV, 0xFFFF);	// PACER CLOCK 
//		WriteWord(resource_no, CLKDIV, 0xFFFF);	// PACER CLOCK
		WriteWord(resource_no, CLKDIV, 0020);	// PACER CLOCK 1uS Sampling
		WriteWord(resource_no, CLKDIV, 0x0000);	// PACER CLOCK
		WriteWord(resource_no, TRIG, 0x80);		// TRIG  MODE
		WriteWord(resource_no, START, 0x1);		// SAMP START
		do{
			retc = ReadWord(resource_no, TRIG);
			retc |= ReadWord(resource_no, TRIG);
		}while (retc = 0);
		status_chk(0x47, 0xff, "TvOX^[g̃Xe[^X");

		// TvOĨtO`FbN
		ReadWord(resource_no, RESET);
		WriteWord(resource_no, MODE, 0x1);		// FIFO MODE
		WriteWord(resource_no, CLKDIV, 0x10);	// PACER CLOCK 
		WriteWord(resource_no, CLKDIV, 0x0);	// PACER CLOCK
		WriteWord(resource_no, CNTNUM, 0x5);	// SAMP NUM
		WriteWord(resource_no, CNTNUM, 0x0);	// SAMP NUM
		WriteWord(resource_no, TRIG, 0x80);		// TRIG  MODE
		WriteWord(resource_no, START, 0x3);		// SAMP START
		status_chk(0xC7, 0xff, "TvOĨXe[^X");

		// ItONA`FbN
		WriteWord(resource_no, STATUS, 0xC0);	// END FLAG CLOR
		status_chk(0x07, 0xff, "ItONÃXe[^X");

		// ehenNA`FbN
		WriteWord(resource_no, STATUS, 0x01);	// FIFO CLOR
		status_chk(0x06, 0xff, "ehenNÃXe[^X");

		// eheneʃ`FbN
		k = 0;
		ReadWord(resource_no, RESET);
		WriteWord(resource_no, MODE, 0x1);		// FIFO MODE
		WriteWord(resource_no, CLKDIV, 0xFFFF);	// PACER CLOCK 
		WriteWord(resource_no, CLKDIV, 0xFFFF);	// PACER CLOCK
		WriteWord(resource_no, CNTNUM, 0xFFFF);	// SAMP NUM
		WriteWord(resource_no, CNTNUM, 0xFFFF);	// SAMP NUM
		WriteWord(resource_no, TRIG, 0x80);		// TRIG  MODE
		WriteWord(resource_no, START, 0x3);		// SAMP START

		for (j = 0; j < 32769 ; j++)
		{
			sts = ReadWord(resource_no,STATUS);
			if ( 0x00 == (sts & 2) ) 
			{ printf("FIFO HALF = (%d)łB\n", k); j=32769;
			  cntdt1 = ReadWord (resource_no,CNTNUM);
			  printf("l(%d)mF܂B\n", k);
			if ( k == (0xffff-cntdt1-1))
				{ printf ("l (%d) łB\n" ,0xffff-cntdt1-1 );} else  { printf ("l (%d) ُłB(%d) \n" , 0xffff-cntdt1-1);}
			}
			WriteWord(resource_no, TRIG, 0x0);		// TRIG  MODE
			WriteWord(resource_no, START, 0x0);		// SAMP STOP
			WriteWord(resource_no, TRIG, 0x80);		// TRIG  MODE
			WriteWord(resource_no, START, 0x3);		// SAMP START
			k = k+1;
		}

		rv = Stop_Driver(resource_no);
		if (rv != 0)
		{
			printf("Stop_DriverŃG[(%d)܂B\n", rv);
			close();
		}
	printf("\n");
	}
	close();
}

void close()
{
	int rv;
	
	rv = Close_Driver();
	if (rv != 0)
	{
		printf("Close_DriverŃG[(%d)܂B\n", rv);
	}
	exit(-1);
}

void status_chk(BYTE expect, BYTE mask, char *message)
{
	BYTE data;

	data = ReadWord(resource_no, STATUS);
	printf("%s(%02xH)", message, data);
	printf(((data & mask) == expect) ? "łB\n" : "ُłB\n");
}





