/**************************************************************************/
/***    MDI-281PCI(WDM) Sample Header :									***/
/***                                           (C) MICRO SCIENCE        ***/
/***	2003.10.08	First Rel.											***/
/**************************************************************************/
#ifdef __cplusplus
	extern "C" {
#endif

#define BOARD_NAME	"MDI-281PCI"
#define VENDOR_ID	0x13FD
#define	DEVICE_ID	0x0111
#define	BOARD_ID	0x2b


#define FIFO_HALF	512		/* Normaly */

/* Port */
#define	DATA		0
#define BITN		8
#define BRDNUM		8
#define	CLKSEL		0x0A
#define	CLKDIV		0x0C
#define	CNTNUM		0x0E
#define TRIG		0x10
#define	START		0x12
#define	INTRSRC		0x14
#define	INTROUT		0x16
#define STATUS		0x18
#define STSCLR		0x18
#define	DIO			0x1C
#define	MODE		0x1E
#define	RESET		0x1E

/* CLKSEL */
#define EXT_RISE	0x90
#define EXT_FALL	0x10
#define INT_8M		0x20
#define INT_10M		0x00

/* TRIG */
#define	SOFT_TRIG	0x80
#define	EXT_TRIG	0x40
#define	INT_TRIG	0x20
#define	PLUS		0x10
#define	MINUS		0x00
#define	EDGE		0x08
#define	LEVEL		0x00
#define	STOP		0x00


/* Status */
#define	EOS_FLAG	0x80
#define	INTR_FLAG	0x40
#define	CLOCK_FLAG	0x20
#define	TRG_FLAG	0x10
#define	SMP_ERR		0x04
#define	NOT_HALF	0x02
#define	NOT_EMPTY	0x01

/* INTRSRC */
#define	INTR_HALF_FULL	0x40
#define	INTR_NOT_EMPTY	0x20
#define	INTR_EOS		0x08
#define	INTR_TRGD		0x04
#define	INTR_EXT_RISE	0x82
#define	INTR_EXT_FALL	0x02
#define	INTR_CLOCK		0x01

/* INTROUT */
#define	INTR_EN		0x01
#define	INTR_DIS	0x00

#ifdef __cplusplus
	}
#endif
