#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "port_2k.h"
#include "mdi281.h"

void close(void);
void status_chk(BYTE expect, BYTE mask, char *message);

int resource_no;

void main(void)
{
	int	i, j, brd_num, rv, device_id[8], index[8];
	BYTE data,sts;
	WORD bit0_15,bit16_31,bit32_47,bit48_63;
	BOOL quit, err;

	for (i = 0; i <= 7; i++)
	{
		device_id[i] = -1;
		index[i] = -1;
	}

	brd_num = 0;
	rv = Open_Driver(device_id);
	if (rv != 0)
	{
		printf("Open_DriverŃG[(%d)܂B\n", rv);
		exit (-1);
	}

	for (i = 0; i <= 7; i++)
		if (DEVICE_ID ==device_id[i])
			index[brd_num++] = i;

	if (brd_num == 0)
	{
		printf("%soł܂B\n", BOARD_NAME);
		close();
	}
	else
		printf("%s%do܂B\n", BOARD_NAME, brd_num);

	for (i = 0; i < brd_num; i++)
	{
		printf("%dԖڂɌoꂽ{[hTvO܂B\n", i + 1);
		rv = Start_Driver(index[i], 2, &resource_no);
		if (rv != 0)
		{
			printf("Open_DriverŃG[(%d)܂B\n", rv);
			close();
		}

		// TvOf[^`FbN
		ReadWord(resource_no, RESET);
		WriteWord(resource_no, MODE, 0x1);		// FIFO MODE
		WriteWord(resource_no, BITN, 0x3);		// 64BIT INPUT
		WriteWord(resource_no, CLKDIV, 0xFF);	// PACER CLOCK 
		WriteWord(resource_no, CLKDIV, 0x0);	// PACER CLOCK
		WriteWord(resource_no, CNTNUM, 0x05);	// SAMP NUM
		WriteWord(resource_no, CNTNUM, 0x0 );	// SAMP NUM
		WriteWord(resource_no, TRIG, 0x80);		// TRIG  MODE
		WriteWord(resource_no, START, 0x3);		// SAMP START
		for (j = 0; j < 3  ; j++)
		{
			bit0_15  = ReadWord(resource_no,DATA);
			bit16_31 = ReadWord(resource_no,DATA);
			bit32_47 = ReadWord(resource_no,DATA);
			bit48_63 = ReadWord(resource_no,DATA);
			printf("%d -  bit15`0= %x   bit31`16= %x  bit47`32= %x  bit63`48= %x \n" ,j , bit0_15,bit16_31,bit32_47,bit48_63 );

		}

		rv = Stop_Driver(resource_no);
		if (rv != 0)
		{
			printf("Stop_DriverŃG[(%d)܂B\n", rv);
			close();
		}
	}
	close();
}

void close()
{
	int rv;
	
	rv = Close_Driver();
	if (rv != 0)
	{
		printf("Close_DriverŃG[(%d)܂B\n", rv);
	}
	exit(-1);
}

void status_chk(BYTE expect, BYTE mask, char *message)
{
	BYTE data;

	data = ReadWord(resource_no, STATUS);
	printf("%s(%02xH)", message, data);
	printf(((data & mask) == expect) ? "łB\n" : "ُłB\n");
}





